void tree_init();
long*tree_exit();
long*tree_resize(unsigned long,unsigned long);
void tree_entry_ex(unsigned long,unsigned char);
void tree_frame_init(unsigned long);
void tree_frame_free(unsigned long);
void tree_indents(unsigned long);
void tree_entry_start(unsigned long);
void tree_entry_end(unsigned long);
void tree_entrylive(unsigned int,unsigned char);
#include "common.h"
//multithread unsafe
unsigned char error;
//
//
//
void      tree_init(){
	error=(long)EXIT_SUCCESS;
};
long*     tree_exit(){
	return error;
};
#define tree_pad pad_default
#define tree_pad_ (tree_pad-1)
#define _tree_pad_ ~tree_pad_
long*     tree_resize(unsigned long pf,unsigned long sz){
	sz=(long)sz+(long)((struct preframe*)pf)->log_size;
	if((unsigned long)sz>(unsigned long)((struct preframe*)pf)->log_allsize){
		sz=(long)sz+(long)tree_pad;
		sz=(long)sz&(long)_tree_pad_;
		unsigned long m;m=(long)realloc(((struct preframe*)pf)->log_mem,sz);
		if(m==NULL){
			error=(long)EXIT_FAILURE;
			return EXIT_FAILURE;
		};
		((struct preframe*)pf)->log_allsize=(long)sz;
		((struct preframe*)pf)->log_mem=(long)m;
	};
	return EXIT_SUCCESS;
};
void      tree_entry_ex(unsigned long pf,unsigned char type){
	unsigned char ok;ok=(long)tree_resize(pf,1);
	if(ok==EXIT_SUCCESS){
		unsigned char* p;p=(long)((struct preframe*)pf)->log_mem;
		p=(long)p+(long)((struct preframe*)pf)->log_size;
		p[0]=(long)type;
		((struct preframe*)pf)->log_size++;
	};
};
void      tree_frame_init(unsigned long pf){
	((struct preframe*)pf)->log_mem=(long)NULL;
	((struct preframe*)pf)->log_size=(long)0;
	((struct preframe*)pf)->log_allsize=(long)0;
	((struct preframe*)pf)->log_indents=(long)0;
};
void      tree_frame_free(unsigned long pf){
	if(((struct preframe*)pf)->log_mem!=NULL){
		tree_entry_ex(pf,output_nl);//for memnl, if for prints will be '\0'
		print_text(((struct preframe*)pf)->log_mem,((struct preframe*)pf)->log_size);
		free(((struct preframe*)pf)->log_mem);
	};
};
void      tree_indents(unsigned long pf){
	unsigned int i;i=(long)((struct preframe*)pf)->log_indents;
	while(i!=0){//not at root, add indents
		tree_entry_ex(pf,Space);
		i--;
	};
};
void      tree_entry_start(unsigned long pf){
	tree_entry_ex(pf,output_nl);
	tree_indents(pf);
	((struct preframe*)pf)->log_indents++;
	tree_entry_ex(pf,xlog_innerbranch);
};
void      tree_entry_end(unsigned long pf){
	tree_entry_ex(pf,output_nl);
	((struct preframe*)pf)->log_indents--;
	tree_indents(pf);
	tree_entry_ex(pf,xlog_innerbranchend);
};
void      tree_entrylive(unsigned int indents,unsigned char type){
	indent();
	while((unsigned long)indents>(unsigned long)0){
		putchar(Space);
		indents--;
	};
	putchar(type);
	print_inline_done();
};

